<?php
/*
    Plugin Name: imwprobot
    Plugin URI: http://www.imwpweb.com/tag/imwprobot
    Description: 蜂集采集器，wordpress上最强大的自动采集插件！
    Version: 4.10
    Author: imwpweb
    Author URI: http://www.imwpweb.com
*/

define('IMWPROBOT_URL', plugin_dir_url(__FILE__));
define('IMWPROBOT_DIR', __DIR__);
define("IMWPROBOT", "imwprobot");
define("IMWPROBOT_VERSION", 408000);
// 余额不足报错
!defined('BALANCE_EMTY') || define('BALANCE_EMPTY', 10000);

// 移到最后激活
add_filter('pre_update_option_active_plugins', function ($plugins) {
    $currentPlugin = plugin_basename(__FILE__);
    $key = array_search($currentPlugin, $plugins);
    if ($key === false) {
        return $plugins;
    }
    unset($plugins[$key]);
    $plugins[] = $currentPlugin;
    return $plugins;
});

// 创建数据库，避免imwpf插件没安装导致创建失败
require_once __DIR__ . "/modules/data/Plugin.php";
add_action('activate_plugin', function($pluginName) {
    if (basename($pluginName) != "imwprobot.php") {
        return;
    }
    $Plugin = new \imwprobot\modules\data\Plugin();
    $Plugin->activate();
});

if (!class_exists('imwpf\modules\Form')) {
    add_action('admin_notices', function () {
        echo "<div class='update-nag notice notice-warning inline'>蜂集采集器需要imwpf环境支持，请安装<a href='http://www.imwpweb.com/400.html' target='_blank'>imwpf插件!</a></div>";
    });
    return false;
}

$api = new  imwprobot\src\API();
$api->init();

if (is_admin()) {
    new imwprobot\admin\ui();
}
