<script type="text/javascript">
    var formData = <?php  echo json_encode($['data']); ?>;
    console.log(formData);
    // 内容keymap，用于将值绑定到form上
    var contentKeyMap = {
        'title': {
            'match_type': 'rules[content][title][match_type]',
            'regexp': 'rules[content][title][regexp]',
            'xpath': 'rules[content][title][xpath]',
            'fixstr': 'rules[content][title][fixstr]',
            'randnum': 'rules[content][title][randnum]',
            'json': 'rules[content][title][json]',
            'jquery': 'rules[content][title][jquery]',
            'jquery_attr': 'rules[content][title][jquery_attr]',
            'wenxin_prompt': 'rules[content][title][wenxin_prompt]',
            'regexp_mode': 'rules[content][title][regexp_mode]',
            'filter': 'rules[content][title][filter]',
            'translate': 'rules[content][title][translate]',
            'replace': 'rules[content][title][replace]',
            'buildin': 'rules[content][title][buildin]',
            'high_level_head': 'rules[content][title][high_level_head]',
            'delete_match_content': 'rules[content][title][delete_match_content]',
            'from_title': 'rules[content][title][from_title]',
        },
        'content': {
            'match_type': 'rules[content][content][match_type]',
            'regexp': 'rules[content][content][regexp]',
            'xpath': 'rules[content][content][xpath]',
            'fixstr': 'rules[content][content][fixstr]',
            'randnum': 'rules[content][content][randnum]',
            'jquery': 'rules[content][content][jquery]',
            'jquery_attr': 'rules[content][content][jquery_attr]',
            'wenxin_prompt': 'rules[content][content][wenxin_prompt]',
            'json': 'rules[content][content][json]',
            'regexp_mode': 'rules[content][content][regexp_mode]',
            'filter': 'rules[content][content][filter]',
            'translate': 'rules[content][content][translate]',
            'save_attachments_type': 'rules[content][content][save_attachments_type]',
            'nlp': 'rules[content][content][nlp]',
            'nlp_tags_num': 'rules[content][content][nlp_tags_num]',
            'nlp_abstract_length': 'rules[content][content][nlp_abstract_length]',
            'replace': 'rules[content][content][replace]',
            'buildin': 'rules[content][content][buildin]',
            'paging': {
                'paginghead': 'rules[content][content][paging][head]',
                'list_area_match_type': 'rules[content][content][paging][list_area_match_type]',
                'list_area': 'rules[content][content][paging][list_area]',
                'list_area_xpath': 'rules[content][content][paging][list_area_xpath]',
                // 'list_area_json': 'rules[content][content][paging][list_area_json]',
                'link_include': 'rules[content][content][paging][link_include]',
                'link_exclude': 'rules[content][content][paging][link_exclude]',
                'title_include': 'rules[content][content][paging][title_include]',
                'title_exclude': 'rules[content][content][paging][title_exclude]',
                'title_max_len': 'rules[content][content][paging][title_max_len]',
                'title_min_len': 'rules[content][content][paging][title_min_len]',
            },
            'data_source_head': 'rules[content][content][data_source_head]',
            'data_source': 'rules[content][content][data_source]',
            'data_field': 'rules[content][content][data_field]',
            'ajax_request_head': 'rules[content][content][ajax_request_head]',
            'ajax_request': 'rules[content][content][ajax_request]',
            'ajax_request_type': 'rules[content][content][ajax_request_type]',
            'ajax_request_params': 'rules[content][content][ajax_request_params]',
            'high_level_head': 'rules[content][content][high_level_head]',
            'auto': 'rules[content][content][auto]',
            'delete_match_content': 'rules[content][content][delete_match_content]',
        },

        'category': {
            'match_type': 'rules[content][category][match_type]',
            'json': 'rules[content][category][json]',
            'regexp': 'rules[content][category][regexp]',
            'xpath': 'rules[content][category][xpath]',
            'fixstr': 'rules[content][category][fixstr]',
            'randnum': 'rules[content][category][randnum]',
            'jquery': 'rules[content][category][jquery]',
            'jquery_attr': 'rules[content][category][jquery_attr]',
            'wenxin_prompt': 'rules[content][category][wenxin_prompt]',
            'regexp_mode': 'rules[content][category][regexp_mode]',
            'filter': 'rules[content][category][filter]',
            'translate': 'rules[content][category][translate]',
            'sep': 'rules[content][category][sep]',
            'replace': 'rules[content][category][replace]',
            'buildin': 'rules[content][category][buildin]',
            'high_level_head': 'rules[content][category][high_level_head]',
            'delete_match_content': 'rules[content][category][delete_match_content]',
        },

        'author': {
            'match_type': 'rules[content][author][match_type]',
            'json': 'rules[content][author][json]',
            'regexp': 'rules[content][author][regexp]',
            'xpath': 'rules[content][author][xpath]',
            'fixstr': 'rules[content][author][fixstr]',
            'randnum': 'rules[content][author][randnum]',
            'jquery': 'rules[content][author][jquery]',
            'jquery_attr': 'rules[content][author][jquery_attr]',
            'wenxin_prompt': 'rules[content][author][wenxin_prompt]',
            'regexp_mode': 'rules[content][author][regexp_mode]',
            'filter': 'rules[content][author][filter]',
            'replace': 'rules[content][author][replace]',
            'buildin': 'rules[content][author][buildin]',
            'high_level_head': 'rules[content][author][high_level_head]',
            'delete_match_content': 'rules[content][author][delete_match_content]',
        },
        'date': {
            'match_type': 'rules[content][date][match_type]',
            'json': 'rules[content][date][json]',
            'regexp': 'rules[content][date][regexp]',
            'xpath': 'rules[content][date][xpath]',
            'fixstr': 'rules[content][date][fixstr]',
            'randnum': 'rules[content][date][randnum]',
            'jquery': 'rules[content][date][jquery]',
            'jquery_attr': 'rules[content][date][jquery_attr]',
            'wenxin_prompt': 'rules[content][date][wenxin_prompt]',
            'regexp_mode': 'rules[content][date][regexp_mode]',
            'filter': 'rules[content][date][filter]',
            'replace': 'rules[content][date][replace]',
            'buildin': 'rules[content][date][buildin]',
            'high_level_head': 'rules[content][date][high_level_head]',
            'delete_match_content': 'rules[content][date][delete_match_content]',
        },
        'thumbnail': {
            'match_type': 'rules[content][thumbnail][match_type]',
            'json': 'rules[content][thumbnail][json]',
            'regexp': 'rules[content][thumbnail][regexp]',
            'xpath': 'rules[content][thumbnail][xpath]',
            'fixstr': 'rules[content][thumbnail][fixstr]',
            'randnum': 'rules[content][thumbnail][fixstr]',
            'jquery': 'rules[content][thumbnail][jquery]',
            'jquery_attr': 'rules[content][thumbnail][jquery_attr]',
            'wenxin_prompt': 'rules[content][thumbnail][wenxin_prompt]',
            'regexp_mode': 'rules[content][thumbnail][regexp_mode]',
            'filter': 'rules[content][thumbnail][filter]',
            'replace': 'rules[content][thumbnail][replace]',
            'buildin': 'rules[content][thumbnail][buildin]',
            'high_level_head': 'rules[content][thumbnail][high_level_head]',
            'delete_match_content': 'rules[content][thumbnail][delete_match_content]',
        },

        'tag': {
            'match_type': 'rules[content][tag][match_type]',
            'json': 'rules[content][tag][json]',
            'regexp': 'rules[content][tag][regexp]',
            'xpath': 'rules[content][tag][xpath]',
            'fixstr': 'rules[content][tag][fixstr]',
            'randnum': 'rules[content][tag][randnum]',
            'jquery': 'rules[content][tag][jquery]',
            'jquery_attr': 'rules[content][tag][jquery_attr]',
            'wenxin_prompt': 'rules[content][tag][wenxin_prompt]',
            'regexp_mode': 'rules[content][tag][regexp_mode]',
            'filter': 'rules[content][tag][filter]',
            'sep': 'rules[content][tag][sep]',
            'replace': 'rules[content][tag][replace]',
            'buildin': 'rules[content][tag][buildin]',
            'high_level_head': 'rules[content][tag][high_level_head]',
            'delete_match_content': 'rules[content][tag][delete_match_content]',
        },

        'comment': {
            'match_type': 'rules[content][comment][match_type]',
            'json': 'rules[content][comment][json]',
            'regexp': 'rules[content][comment][regexp]',
            'xpath': 'rules[content][comment][xpath]',
            'fixstr': 'rules[content][comment][fixstr]',
            'randnum': 'rules[content][comment][randnum]',
            'jquery': 'rules[content][comment][jquery]',
            'jquery_attr': 'rules[content][comment][jquery_attr]',
            'wenxin_prompt': 'rules[content][comment][wenxin_prompt]',
            'regexp_mode': 'rules[content][comment][regexp_mode]',
            'filter': 'rules[content][comment][filter]',
            'sep': 'rules[content][comment][sep]',
            'replace': 'rules[content][comment][replace]',
            'buildin': 'rules[content][comment][buildin]',
            'high_level_head': 'rules[content][comment][high_level_head]',
            'delete_match_content': 'rules[content][comment][delete_match_content]',
        },

        'comment_author': {
            'match_type': 'rules[content][comment_author][match_type]',
            'json': 'rules[content][comment_author][json]',
            'regexp': 'rules[content][comment_author][regexp]',
            'xpath': 'rules[content][comment_author][xpath]',
            'fixstr': 'rules[content][comment_author][fixstr]',
            'randnum': 'rules[content][comment_author][randnum]',
            'jquery': 'rules[content][comment_author][jquery]',
            'jquery_attr': 'rules[content][comment_author][jquery_attr]',
            'wenxin_prompt': 'rules[content][comment_author][wenxin_prompt]',
            'regexp_mode': 'rules[content][comment_author][regexp_mode]',
            'filter': 'rules[content][comment_author][filter]',
            'sep': 'rules[content][comment_author][sep]',
            'replace': 'rules[content][comment_author][replace]',
            'buildin': 'rules[content][comment_author][buildin]',
            'high_level_head': 'rules[content][comment_author][high_level_head]',
            'delete_match_content': 'rules[content][comment_author][delete_match_content]',
        },

        'template': {
            'match_type': 'rules[content][%s][match_type]',
            'regexp': 'rules[content][%s][regexp]',
            'xpath': 'rules[content][%s][xpath]',
            'fixstr': 'rules[content][%s][fixstr]',
            'randnum': 'rules[content][%s][randnum]',
            'jquery': 'rules[content][%s][jquery]',
            'jquery_attr': 'rules[content][%s][jquery_attr]',
            'wenxin_prompt': 'rules[content][%s][wenxin_prompt]',
            'json': 'rules[content][%s][json]',
            'regexp_mode': 'rules[content][%s][regexp_mode]',
            'filter': 'rules[content][%s][filter]',
            'sep': 'rules[content][%s][sep]',
            'translate': 'rules[content][%s][translate]',
            'replace': 'rules[content][%s][replace]',
            'processor': 'rules[content][%s][processor]',
            'buildin': 'rules[content][%s][buildin]',
            'data_source_head': 'rules[content][%s][data_source_head]',
            'data_source': 'rules[content][%s][data_source]',
            'data_field': 'rules[content][%s][data_field]',
            'ajax_request_head': 'rules[content][%s][ajax_request_head]',
            'ajax_request': 'rules[content][%s][ajax_request]',
            'ajax_request_type': 'rules[content][%s][ajax_request_type]',
            'ajax_request_params': 'rules[content][%s][ajax_request_params]',
            'high_level_head': 'rules[content][%s][high_level_head]',
            'delete_match_content': 'rules[content][%s][delete_match_content]',
        },
    };

    // 列表页面表单
    var listRuleForm = {
        'list_description': 'rules[list][%s][list_description]',
        'link_rule_type': 'rules[list][%s][link_rule_type]',
        'link_rule': 'rules[list][%s][link_rule]',
        'link_rule_jquery': 'rules[list][%s][link_rule_jquery]',
        'link_rule_jsonpath': 'rules[list][%s][link_rule_jsonpath]',
        'link_rule_xpath': 'rules[list][%s][link_rule_xpath]',
        'thumbnail_rule': 'rules[list][%s][thumbnail_rule]',
        'thumbnail_rule_jquery': 'rules[list][%s][thumbnail_rule_jquery]',
        'list_area_head': 'rules[list][%s][list_area_head]',
        'list_area_match_type': 'rules[list][%s][list_area_match_type]',
        'list_area': 'rules[list][%s][list_area]',
        'list_area_xpath': 'rules[list][%s][list_area_xpath]',
        // 'list_area_json': 'rules[list][%s][list_area_json]',
        'high_level_head': 'rules[list][%s][high_level_head]',
        'link_include': 'rules[list][%s][link_include]',
        'link_exclude': 'rules[list][%s][link_exclude]',
        'title_include': 'rules[list][%s][title_include]',
        'title_exclude': 'rules[list][%s][title_exclude]',
        'title_max_len': 'rules[list][%s][title_max_len]',
        'title_min_len': 'rules[list][%s][title_min_len]',
        'replace': 'rules[list][%s][replace]',
        'end': 'rules[list][%s][end]',
    };

    var fields_title = {
        "title": "标题",
        "content": "正文",
        "category": "分类",
        "tag": "标签",
        "author": "作者",
        "date": "日期",
        "thumbnail": "缩略图",
        "comment": "评论",
        "comment_author": "评论作者"
    };

    // 默认的form数据
    var defaultFormData = {
        'name': '',
        'rules': {
            'list': [{
                'list_description': '',
                'link_rule_type': 'jquery',
                'link_rule': '',
                'link_rule_jquery': '',
                'thumbnail_rule': '',
                'thumbnail_rule_jquery': '',
                'list_area_match_type': 'xpath',
                'list_area': '',
                'list_area_xpath': '',
                'link_include': '',
                'link_exclude': '',
                'title_include': '',
                'title_exclude': '',
                'title_min_len': '',
                'title_max_len': '',
                'replace': [
                    ['', '']
                ],
                'end': "1",
            }],
            'content': {
                'title': {
                    'title': '标题',
                    'from_title': '0',
                    'regexp': '|<h1[^>]*>(.*?)</h1>|is',
                    'regexp_mode': '',
                    'jquery': '',
                    'json': '',
                    'delete_match_content': '',
                    'replace': [
                        ['', '']
                    ],
                    'translate': ["zh", "zh"],
                    'ajax': '',
                    'ajax_param': '',
                    'map': '',
                    'buildin': 1
                },
                'content': {
                    'title': '正文',
                    'regexp': '',
                    'regexp_mode': '',
                    'delete_match_content': '',
                    'jquery': '',
                    'json': '',
                    'replace': [
                        ['', '']
                    ],
                    'ajax': '',
                    'ajax_param': '',
                    'map': '',
                    'buildin': 1,
                    'auto': '0',
                    'nlp_tags_num': 3,
                    'nlp_abstract_length': 160,
                    'translate': ["zh", "zh"],
                    'save_attachments_type': ["image"],
                    'paging': {
                        'head': '',
                        'list_area': '',
                        'link_include': '',
                        'link_exclude': '',
                        'title_include': '',
                        'title_exclude': '',
                        'title_min_len': '',
                        'title_max_len': ''
                    },
                    "data_source":"",
                    "data_field": "",
                },
                'category': {
                    'title': '分类目录',
                    'regexp': '',
                    'regexp_mode': '',
                    'delete_match_content': '',
                    'jquery': '',
                    'json': '',
                    'replace': [
                        ['', '']
                    ],
                    'ajax': '',
                    'sep': ',',
                    'ajax_param': '',
                    'map': '',
                    'buildin': 1
                },
                'tag': {
                    'title': '标签',
                    'regexp': '',
                    'regexp_mode': '',
                    'delete_match_content': '',
                    'jquery': '',
                    'json': '',
                    'replace': [
                        ['', '']
                    ],
                    'ajax': '',
                    'ajax_param': '',
                    'map': '',
                    'sep': ',',
                    'buildin': 1
                },
                'author': {
                    'title': '作者',
                    'regexp': '',
                    'regexp_mode': '',
                    'delete_match_content': '',
                    'jquery': '',
                    'json': '',
                    'replace': [
                        ['', '']
                    ],
                    'ajax': '',
                    'ajax_param': '',
                    'map': '',
                    'buildin': 1
                },
                'date': {
                    'title': '发布时间',
                    'regexp': '',
                    'regexp_mode': '',
                    'delete_match_content': '',
                    'jquery': '',
                    'json': '',
                    'replace': [
                        ['', '']
                    ],
                    'ajax': '',
                    'ajax_param': '',
                    'map': '',
                    'buildin': 1
                },
                'thumbnail': {
                    'title': '缩略图',
                    'regexp': '',
                    'regexp_mode': '',
                    'delete_match_content': '',
                    'jquery': '',
                    'json': '',
                    'replace': [
                        ['', '']
                    ],
                    'ajax': '',
                    'ajax_param': '',
                    'map': '',
                    'buildin': 1
                },
                'comment': {
                    'title': '评论',
                    'regexp': '',
                    'regexp_mode': '',
                    'delete_match_content': '',
                    'jquery': '',
                    'json': '',
                    'sep': '@@',
                    'replace': [
                        ['', '']
                    ],
                    'ajax': '',
                    'ajax_param': '',
                    'map': '',
                    'buildin': 1
                },
                'comment_author': {
                    'title': '评论用户',
                    'regexp': '',
                    'regexp_mode': '',
                    'delete_match_content': '',
                    'jquery': '',
                    'json': '',
                    'sep': '@@',
                    'replace': [
                        ['', '']
                    ],
                    'ajax': '',
                    'ajax_param': '',
                    'map': '',
                    'buildin': 1
                }
            },
            'page': {
                'include': '',
                'list_request_method': 'GET',
                'content_request_method': 'GET',
                'cookie': '',
                'proxy': 'no',
            },

            'test': {
                'url': '',
                'level': '',
                'list_url': '',
                'list_level': '',
            }
        }
    };

    /**
     * 替换器的初始个数，用作name的索引
     * @type integer
     */
    var replaceIndex = 0;

    /**
     * 当前的tab key
     * @type string
     */
    var currentTabKey = '';

    /**
     * 获取内容规则dom
     * @return 
     */
    function getContentRuleDom(contentRule) {
        var dom = '';
        for (var i in contentRule) {
            dom += '<div id="content-rule-' + i + '" class="content-rule-container">';
            if (i == "category" || i == "tag" || i == "author") {
                contentKeyMap[i] = contentKeyMap[i] || parseFormTemplate(contentKeyMap['template'], i, true);
            } else {
                contentKeyMap[i] = contentKeyMap[i] || parseFormTemplate(contentKeyMap['template'], i, false);
            }
            if (fields_title.hasOwnProperty(i)) {
                dom += "<h4 class='content-rule-title'>" + fields_title[i] + "</h4>";
            } else {
                dom += "<h4 class='content-rule-title'>自定义标签:" + i + "</h4>";
            }
            dom += createForm(formTemplate, contentKeyMap[i], contentRule[i])
            dom += '</div>'
        }
        //console.log(dom);
        return dom;
    }

    /**
     * 获取内容规则tab dom
     */
    function getcontentRuleTabDom(contentRule) {
        var dom = '';
        for (var i in contentRule) {
            if (!contentRule[i].hasOwnProperty('buildin') || contentRule[i]['buildin'] == 0) {
                var del = '<span class="pull-right del-rule btn btn-outline-primary btn-sm" data-target="' + i + '">-</span>';
            } else {
                var del = '';
            }
            dom += '<li class="clearfix" id="content-rule-tab-' + i + '"" data-target="' + i + '">' + i + del + '</li>';
        }
        return dom;
    }

    /**
     * 获取列表规则tab dom
     */
    function getListRuleTabDom(listRule) {
        var dom = "";
        for (var i in listRule) {
            if (!jQuery.isNumeric(i)) {
                continue;
            }
            dom += '<li class="clearfix" id="list-rule-tab-' + i + '"" data-target="' + i + '">第' + i + '级列表<span class="pull-right del-list-rule btn btn-outline-primary btn-sm" data-target="' + i + '">-</span></li>';
        }
        dom += '<span id="add-list-rule" class="btn btn-outline-primary btn-sm">+</span>';
        return dom;
    }

    /**
     * 获取列表规则dom
     */
    function getListRuleDom(listRule) {
        var dom = '';
        for (var i in listRule) {
            if (!jQuery.isNumeric(i)) {
                continue;
            }
            dom += '<div id="list-rule-' + i + '" class="list-rule-container">';
            form = parseFormTemplate(listRuleForm, i);
            dom += createForm(formTemplate, form, listRule[i]);
            dom += '</div>';
        }
        return dom;
    }

    /**
     * tab 切换
     * @return
     */
    function tabSwitch() {
        tabSwitcher = new TabSwitcher();
        tabSwitcher.add("tab-task-info", jQuery(".tab-task-info"), jQuery(".task-info"));
        tabSwitcher.add("tab-list-rule", jQuery(".tab-list-rule"), jQuery(".list-rule"));
        tabSwitcher.add("tab-list-rule-test", jQuery(".tab-list-rule-test"), jQuery(".list-rule-test"));
        tabSwitcher.add("tab-content-rule", jQuery(".tab-content-rule"), jQuery(".content-rule"));
        tabSwitcher.add("tab-rule-test", jQuery(".tab-rule-test"), jQuery(".rule-test"));
        tabSwitcher.setNextDOM(jQuery("#next-step"));
        tabSwitcher.setPrevDOM(jQuery("#prev-step"));
        tabSwitcher.setEndDOM(jQuery("#submit"));
        tabSwitcher.run();
    }

    /**
     * 使得content rule为激活状态
     * @return
     */
    function activateContentRule(key) {
        jQuery(".content-rule-tab li").removeClass('active');
        jQuery(".content-rule-tab li#content-rule-tab-" + key).addClass('active');
        jQuery(".content-rule-container").hide();
        jQuery("#content-rule-" + key).show();
        currentTabKey = key; //全局tab key
    }

    /**
     * 使列表rule为激活状态
     */
    function activateListRule(key) {
        jQuery(".list-rule-tab li").removeClass('active');
        jQuery(".list-rule-tab li#list-rule-tab-" + key).addClass('active');
        jQuery(".list-rule-container").hide();
        jQuery("#list-rule-" + key).show();
    }

    /**
     * 内容规则切换
     * @return
     */
    function contentRuleSwitch() {
        jQuery(".content-rule-tab").delegate('li', 'click', function() {
            var key = jQuery(this).attr('data-target');
            activateContentRule(key);
        });
    }

    /**
     * 列表规则切换
     */
    function listRuleSwitch() {
        jQuery(".list-rule-tab").delegate('li', 'click', function() {
            var key = jQuery(this).attr('data-target');
            activateListRule(key);
        });
    }

    /**
     * 添加内容规则
     */
    function addContentRule() {
        jQuery(".content-rule-tab .add-rule").click(function() {
            var key = jQuery("#content-rule-key").val();
            jQuery("#content-rule-key").val('');
            if (!key) {
                alert('输入key');
                return false;
            }
            buildin = ["title", "content", "category", "tag", "author", "thumbnail", "comment", "comment_author", "date"];
            for (var i in buildin) {
                if (key == buildin[i]) {
                    alert("key不可用");
                    return false;
                }
            }
            contentRule = {};
            defaultContentRule = defaultFormData['rules']['content']['content'];
            defaultContentRule['buildin'] = 0;
            defaultContentRule['title'] = "自定义标签:" + key;
            contentRule[key] = defaultContentRule;
            jQuery(".content-rule-tab").append('<li class="clearfix" id="content-rule-tab-' + key + '" data-target="' + key + '">' + key + '<span class="pull-right del-rule btn btn-primary" data-target="' + key + '">-</span></li>');
            var contentRuleDom = getContentRuleDom(contentRule);
            jQuery("#content-rule-container").append(contentRuleDom);
            activateContentRule(key);
        });


        jQuery(".content-rule-tab").delegate('.del-rule', 'click', function() {
            var target = jQuery(this).attr('data-target');
            jQuery("li#content-rule-tab-" + target).remove();
            jQuery("#content-rule-" + target).remove();
        });
    }


    /**
     * 添加列表规则
     */
    function addListRule() {
        formData = formData || defaultFormData;
        // 数据和表单绑定
        jQuery("#list-rule-container").delegate('input, textarea', 'change', function() {
            var name = jQuery(this).attr('name');
            var val = jQuery(this).val();
            name = name.replace('rules', "[rules]").replace(/\[/g, "['").replace(/\]/g, "']");
            console.log(name)
            eval('formData' + name + '="' + val + '"');
        });

        // 添加一个列表规则
        jQuery(".list-rule-tab").delegate('#add-list-rule', 'click', function() {
            formData['rules']['list'] = formData['rules']['list'] || [];
            formData['rules']['list'].push(defaultFormData['rules']['list'][0]);
            jQuery(".list-rule-tab").html(getListRuleTabDom(formData['rules']['list']));
            jQuery("#list-rule-container").html(getListRuleDom(formData['rules']['list']));
            activateListRule(formData['rules']['list'].length - 1);
        });

        // 删除一个列表规则规则
        jQuery(".list-rule-tab").delegate('.del-list-rule', 'click', function() {
            var target = jQuery(this).attr('data-target');
            formData['rules']['list'].splice(target, 1);
            jQuery(".list-rule-tab").html(getListRuleTabDom(formData['rules']['list']));
            jQuery("#list-rule-container").html(getListRuleDom(formData['rules']['list']));
            activateListRule(formData['rules']['list'].length - 1);
            return false;
        });
    }


    /**
     * 初始化表单数据
     * @return
     */
    function initFormData(formData) {
        var form = new FormCreater();
        // 初始化表单数据
        form.text("name", formData['name'], "规则名称", "设置一个规则名称", true)
            .textarea("rules[page][cookie]", formData['rules']['page']['cookie'], "cookie", "如果网站需要cookie才能访问，请在此填写")
            .select("rules[page][proxy]", {
                "no": "不使用",
                "yes": "使用固定代理",
                "api": "使用代理接口",
            }, formData['rules']['page']['proxy'], "代理", "固定代理:每次抓取时该规则将会从固定代理配置中理随机选择一个有效代理。<br/>代理接口:每次抓取从代理接口中查询一个代理。")
            .text("rules[page][include]", formData['rules']['page']['include'], "完整检测", "网页必须包含此处设定的内容才会被认定是完整的，反之则会进行重试，确保网页的完整性");

        jQuery("#task-base-info").html(form.getInput());

        jQuery('input[name="id"]').val(formData['id']);

        // 测试数据
        jQuery('input[name="rules[test][url]"]').val(formData['rules']['test']['url']);
        jQuery('input[name="rules[test][level]"]').val(formData['rules']['test']['level']);
        jQuery('input[name="rules[test][list_url]"]').val(formData['rules']['test']['list_url']);
        jQuery('input[name="rules[test][list_level]"]').val(formData['rules']['test']['list_level']);

        contentRule = formData['rules']['content'];
        // 初始化tab dom
        jQuery(".content-rule-tab").append(getcontentRuleTabDom(contentRule));
        // 初始化content rule dom
        jQuery("#content-rule-container").append(getContentRuleDom(contentRule));
        // 设置激活状态
        var key = '';
        for (var i in formData['rules']['content']) {
            key = i;
        }
        activateContentRule(key);

        // 初始化list rule dom
        var listRule = formData['rules']['list'];
        // 初始化列表规则tab
        jQuery(".list-rule-tab").html(getListRuleTabDom(listRule));
        // 初始化列表项
        jQuery("#list-rule-container").html(getListRuleDom(listRule));
        activateListRule(0);
    }

    function ruleTest(btn, form, dataContainer, testType) {
        var crawlResult = new CrawlResult();
        btn.click(function() {
            dataContainer.html('<img style="width:40px;height:40px; margin:10px 0px 20px 0px" src="<?php  echo IMWPROBOT_URL . '/pages/image/loading.gif'; ?>">');
            var formData = form.serialize();
            var action = "rules_test";
            if (testType == "list") {
                action = "list_rules_test";
            }
            jQuery.ajax({
                'url': ajaxurl + '?action=' + action,
                'method': 'POST',
                'data': formData,
                'timeout': 120000,
                'dataType': 'json',
                'success': function(data) {
                    if (data.errno != 0) {
                        dataContainer.html('<p class="alert alert-warning">抓取失败，错误信息:' + data.msg + '</p>');
                        return;
                    }
                    if (!data.data || data.data.content.length == 0) {
                        dataContainer.html('<p class="alert alert-warning">未知错误，内容为空，请重试一次！</p>');
                        return;
                    }
                    if (testType == "list") {
                        crawlResult.setLinks(data.data.links);
                    } else {
                        console.log(data.data.content);
                        crawlResult.setContent(data.data.content).setLinks(data.data.links);
                    }
                    crawlResult.renderDOM(dataContainer);
                },
                'error': function(e) {
                    dataContainer.html('<p class="alert alert-warning">请求超时了！</p>');
                }
            });
        });
        dataContainer.on("click", ".view-html", function() {
            crawlResult.switchMode().renderDOM(dataContainer);
        });
    }


    jQuery(document).ready(function($) {
        // 默认的formData
        formData = formData || defaultFormData;

        // 避免formData规则丢失
        formData["rules"] = formData["rules"] || defaultFormData["rules"];
        formData["rules"]["list"] = formData["rules"]["list"] || defaultFormData["rules"]["list"];
        formData["rules"]["content"] = formData["rules"]["content"] || defaultFormData["rules"]["content"];
        formData["rules"]["page"] = formData["rules"]["page"] || defaultFormData["rules"]["page"];

        initFormData(formData);

        // tab切换
        tabSwitch();
        // 内容规则切换
        contentRuleSwitch();
        // 添加内容规则
        addContentRule();
        // 列表规则切换
        listRuleSwitch();
        // 添加列表规则
        addListRule();

        // 增加内容替换规则
        $("#content-rule-container, #list-rule-container").delegate('.add-replace', 'click', function() {
            var name = $(this).attr("data-name");
            var index = $(this).attr("data-index");
            dom = getReplaceDOM(formTemplate["replace"], name, [
                ['', '']
            ], index)
            $(this).parent().parent().find(".replace-container").append(dom[0]);
            $(this).attr("data-index", dom[1])
        });

        // 删除内容替换规则
        $('#content-rule-container, #list-rule-container').delegate('.del-replace', 'click', function() {
            $(this).parents(".form-replace").remove();
        });

        // 抓取测试
        ruleTest($("#rule-test-btn"), $("#form"), $("#rule-test-table"));
        ruleTest($("#list-rule-test-btn"), $("#form"), $("#list-rule-test-table"), "list");

    });
</script>

<div id="imwprobot">

    <div class="row">
        <div class="col-12">
            <?php  if (!empty($['msg'])) { if ($['errno'] == 0) { echo '<p class="alert alert-success">'; } else { echo '<p class="alert alert-warning">'; } echo $['msg']; echo '</p>'; } ?>
            <form id="form" class="form-horizontal" action="" method="POST">
                <ul class="tab clearfix">
                    <li class="tab-task-info active">基本信息</li>
                    <li class="tab-list-rule">列表规则</li>
                    <li class="tab-list-rule-test">列表抓取测试</li>
                    <li class="tab-content-rule">内容规则</li>
                    <li class="tab-rule-test">内容抓取测试</li>
                </ul>
                <input type="hidden" name="id" value="">
                <input type="hidden" name="submit" value="1">

                <!--{{基本信息区域-->
                <div id="task-base-info" class="task-info tab-content">

                </div>
                <!--基本信息区域}}-->


                <!--{{列表规则区域-->
                <div class="list-rule tab-list tab-content">
                    <div class="row">
                        <div class="col-3">
                            <ul class="list-rule-tab">
                                <!--菜单区域将会用list rule填充-->
                            </ul>
                        </div>

                        <!--{{列表规则-->
                        <div class="col-9">
                            <div id="list-rule-container">
                                <!--js将会填充这块区域-->
                            </div>
                        </div>
                        <!--列表规则}}-->

                    </div>
                </div>
                <!--列表规则区域}}-->

                <!--{{测试列表规则是否符合预期区域-->
                <div class="list-rule-test tab-content common-tab-content">

                    <div class="form-inline mb-2">
                        <div class="mr-4">测试地址</div>
                        <input class="form-control col" type="text" name="rules[test][list_url]" value="" />
                        <div class="btn btn-outline-primary ml-2 fr" id="list-rule-test-btn">抓取测试</div>
                    </div>

                    <div class="form-inline mb-2">
                        <div class="mr-4">页面层级</div>
                        <input class="form-control col" type="text" name="rules[test][list_level]" value="" placeholder="相对于入口的层级，入口为0" />
                    </div>

                    <div class="table-responsive" id="list-rule-test-table"></div>
                </div>
                <!--测试列表规则是否符合预期区域-->

                <!--{{正文规则区域-->
                <div class="content-rule tab-content">
                    <div class="row">
                        <div class="col-3">
                            <ul class="content-rule-tab">
                                <div class="form-inline">
                                    <input class="col-8 ml-2" type="text" id="content-rule-key" value="" placeholder="增加标签">
                                    <span class="col add-rule btn btn-outline-primary btn-sm">添加</span>
                                </div>
                                <!--菜单区域将会用contentrule填充-->
                            </ul>
                        </div>

                        <!--{{内容规则-->
                        <div class="col-9">
                            <div id="content-rule-container">
                                <!--js将会填充这块区域-->
                            </div>
                        </div>
                        <!--内容规则}}-->

                    </div>
                </div>
                <!--正文规则区域}}-->

                <!--{{测试规则是否符合预期区域-->
                <div class="rule-test tab-content common-tab-content">

                    <div class="form-inline mb-2">
                        <div class="mr-4">测试地址</div>
                        <input class="form-control col" type="text" name="rules[test][url]" value="" />
                        <div class="btn btn-outline-primary ml-2 fr" id="rule-test-btn">抓取测试</div>
                    </div>

                    <div class="form-inline mb-4">
                        <div class="mr-4">页面层级</div>
                        <input class="form-control col" type="text" name="rules[test][level]" value="" placeholder="相对于入口的层级，入口为0" />
                    </div>

                    <div class="table-responsive" id="rule-test-table"></div>
                </div>
                <!--测试规则是否符合预期区域-->

                <div class="col align-self-end">
                    <span class="btn btn-outline-primary tab-btn" id="prev-step">上一步</span>
                    <span class="btn btn-outline-primary tab-btn" id="next-step">下一步</span>
                    <input type="submit" class="btn btn-outline-primary tab-btn" id="submit" value="提交" />
                </div>

            </form>


        </div>

    </div>

</div>