<?php
 $ = get_post_types(array('public' => true), 'objects'); $ = array(); foreach ($ as $) { $[$->name] = $->label; } $ = array('standard' => '标准', 'aside' => '日志', 'image' => '图像', 'video' => '视频', 'quote' => '引语', 'link' => '链接', 'gallery' => '相册', 'audio' => '音频'); $ = get_terms(array('hide_empty' => false)); $ = array(); $ = array(); foreach ($ as $) { if ($->taxonomy == "post_format" || $->taxonomy == "nav_menu") { continue; } $[$->taxonomy][$->taxonomy . ":" . $->term_id] = $->name; if (!isset($[$->taxonomy])) { $[$->taxonomy] = $->taxonomy; } } ?>
<script type="text/javascript">
    var formData = <?php  echo json_encode($['data']); ?>;
    console.log(formData);
    var postFormat = <?php  echo json_encode($); ?>;
    var postTypes = <?php  echo json_encode($); ?>;
    var postTerms = <?php  echo json_encode($); ?>;
    var g_taxonomy = <?php  echo json_encode($); ?>;
    // 默认的form数据
    var defaultFormData = {
        'name': '',
        'publish_type': '',
        'rules': {
            'content': {
                'post_title': {
                    'fields': '$title$',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 1
                    },
                    'builtin': 1,
                    'test_data': '测试标题'
                },
                'post_excerpt': {
                    'fields': '$content_abstract$',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 0
                    },
                    'builtin': 1,
                    'test_data': '测试摘要'
                },
                'post_content': {
                    'fields': '$content$',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 1
                    },
                    'builtin': 1,
                    'test_data': '测试内容'
                },
                'post_category': {
                    'fields': '$category$',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 0
                    },
                    'builtin': 1,
                    'test_data': '测试分类'
                },
                'category_id': {
                    'fields': '',
                    'builtin': 1,
                    'test_data': '1'
                },
                'tags_input': {
                    'fields': '$tag$',
                    'tax': 'post_tag',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 0
                    },
                    'builtin': 1,
                    'test_data': '测试标签'
                },
                'post_author': {
                    'fields': '$author$',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 0
                    },
                    'builtin': 1,
                    'description': '确保字段是已经存在的用户名，可以填写固定用户名',
                    'test_data': '测试作者'
                },
                'post_date': {
                    'fields': '$date$',
                    'builtin': 1,
                    'description': '发布日期，为空则使用当前时间',
                    'test_data': '2023-01-01 01:02:03'
                },
                'thumbnail': {
                    'fields': '$thumbnail$',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 0
                    },
                    'builtin': 1,
                    'test_data': ''
                },
                'comments': {
                    'fields': '$comment$',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 0
                    },
                    'description': '评论内容，默认为<code>$comment$</code>，多个评论用##分隔',
                    'builtin': 1,
                    'test_data': ''
                },
                'comment_authors': {
                    'fields': '$comment_author$',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 0
                    },
                    'description': '评论用户，默认为<code>$comment_author$</code>，多个评论用户用##分隔',
                    'builtin': 1,
                    'test_data': ''
                },
                'taxonomy': {
                    'fields': 'category',
                    'builtin': 1,
                    'test_data': 'category',
                },
                'post_format': {
                    'fields': 'standard',
                    'builtin': 1,
                    'test_data': 'standard',
                },
                'post_type': {
                    'fields': 'post',
                    'builtin': 1,
                    'test_data': 'post',
                },
                'post_parent': {
                    'fields': '0',
                    'builtin': 1,
                    'test_data': '0',
                }
            },
            'sqlite': {
                'path': ''
            },
            'term': {
                'term_name': {
                    'fields': '$term_name$',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 1
                    },
                    'builtin': 1,
                    'test_data': '分类名'
                },
                'parent_term_name': {
                    'fields': '$parent_term_name$',
                    'condition': {
                        'include': '',
                        'exclude': '',
                        'min_len': 1
                    },
                    'builtin': 1,
                    'test_data': '父分类'
                }
            },
            'publish_type': '',
        }
    };

    var fields_label = {
        "post_title": "标题",
        "post_excerpt": "摘要",
        "post_content": "正文",
        "post_category": "分类目录(自动创建)",
        "category_id": "分类选择(固定分类)",
        "tags_input": "标签",
        "post_author": "作者",
        "thumbnail": "缩略图",
        "post_format": "文章格式",
        "post_type": "文章类型",
        "taxonomy": "分类法",
        "post_parent": "文章父ID",
        "comments": "评论",
        "comment_authors": "评论用户",
        "post_date": "发布日期",
        "term_name": "分类名",
        "parent_term_name": "父分类名"
    };

    /**
     * 替换器的初始个数，用作name的索引
     * @type integer
     */
    var replaceIndex = 0;

    /**
     * 当前的tab key
     * @type string
     */
    var currentTabKey = '';

    /**
     * 获取内容规则dom
     * @return 
     */
    function getRuleDom(rule, key) {
        var dom = '';
        var key = key || "content";
        for (var i in rule) {
            idkey = i.replace(/%/g, '');
            var description = "";
            console.log(rule[i]);
            if (rule[i].hasOwnProperty("description")) {
                description = rule[i]["description"];
            }
            dom += '<div id="rule-' + idkey + '" class="rule-container">';
            dom += getRuleItemFormInput(rule[i], "rules[" + key + "][" + i + "]");
            dom += '</div>'
        }
        // console.log(dom);
        return dom;
    }

    /**
     * 规则转化成form格式
     */
    function getRuleItemFormInput(ruleItem, prefix) {
        var sform = new FormCreater();
        if (prefix == "rules[content][post_format]") {
            sform.select(prefix + "[fields]", postFormat, ruleItem["fields"], "格式", "选择文章格式");
            sform.hidden(prefix + "[builtin]", ruleItem["builtin"]);
            return sform.getInput();
        }

        if (prefix == "rules[content][post_type]") {
            sform.select(prefix + "[fields]", postTypes, ruleItem["fields"], "类型", "文章类型，支持主题或者插件自定义的类型");
            sform.hidden(prefix + "[builtin]", ruleItem["builtin"]);
            return sform.getInput();
        }

        if (prefix == "rules[content][taxonomy]") {
            sform.select(prefix + "[fields]", g_taxonomy, ruleItem["fields"], "分类法", "当分类目录是自动创建的时候,可以在此设置默认的分类法. <br/>将会根据采集的目录字段自动在此分类法下创建分类");
            sform.hidden(prefix + "[builtin]", ruleItem["builtin"]);
            return sform.getInput();
        }

        if (prefix == "rules[content][category_id]") {
            // 分类选择的tab switcher
            description = "如果选择固定分类，那么发布的分类将以这个为准。";
            for (tax in postTerms) {
                sform.multicheck(prefix + "[fields]", postTerms[tax], ruleItem["fields"], "分类法:" + tax, description);
            }
            sform.hidden(prefix + "[builtin]", ruleItem["builtin"]);
            return sform.getInput();
        }

        for (i in ruleItem) {
            if (i == "fields") {
                if (prefix == "rules[content][post_excerpt]") {
                    description = "填写采集的摘要字段";
                    sform.textarea(prefix + "[" + i + "]", ruleItem["fields"], "摘要字段", description, false);
                    sform.hidden(prefix + "[builtin]", ruleItem["builtin"]);
                    continue;
                }

                var description = "";
                if (prefix == "rules[content][post_type]") {
                    description = "文章类型，如果不是自定义类型，请保持post不变。";
                } else if (prefix == "rules[content][post_category]") {
                    description = "支持父子分类形式: 父分类>子分类。使用模板变量如: <code>玄幻>$category$</code>";
                } else if (ruleItem.hasOwnProperty("description")) {
                    description = ruleItem["description"];
                } else {
                    description = "填写采集的字段或者固定文字。采集字段使用模板变量，比如<code>$title$</code><code>$content$</code><code>$category$</code> 等";
                }
                sform.textarea(prefix + "[" + i + "]", ruleItem[i], "内容", description);

            } else if (i == "condition") {
                for (j in ruleItem[i]) {
                    if (j == "include") {
                        sform.text(prefix + "[" + i + "][" + j + "]", ruleItem[i][j], "必须包含", "包含上面设置的文字才会被发布，否则不会发布");
                    } else if (j == "exclude") {
                        sform.text(prefix + "[" + i + "][" + j + "]", ruleItem[i][j], "不能包含", "包含上面设置的文字不会被发布，否则会发布");
                    } else if (j == "min_len") {
                        sform.text(prefix + "[" + i + "][" + j + "]", ruleItem[i][j], "最小长度", "内容长度大于上面设置的长度才会被发布，否则不会发布");
                    }
                }
            } else if (i == "builtin" || i == "buildin") {
                sform.hidden(prefix + "[builtin]", ruleItem[i]);
            } else if (i == "serialize") {
                sform.select(prefix + "[" + i + "]", ["不序列化", "使用PHP序列化"], ruleItem[i], "序列化", "如果你的主题自定义字段的值是数组，请使用PHP序列化。字段使用json格式，程序会转为数组再序列化。此时的模板标签为 <code>$title$</code> 这种格式");
            } else if (i == "tax") {
                sform.select(prefix + "[" + i + "]", g_taxonomy, ruleItem[i], "分类法", "如果该字段是一个自定义的分类法字段，请在此设置分类法");
            }
        }
        return sform.getInput();
    }

    /**
     * 获取内容规则tab dom
     */
    function getRuleTabDom(rule) {
        var dom = '';
        for (var i in rule) {
            idkey = i.replace(/%/g, '');
            if (obj_get(rule[i], "buildin", 0) == 1 || obj_get(rule[i], "builtin", 0) == 1) {
                var del = '';
            } else {
                var del = '<span class="pull-right del-rule btn btn-outline-primary" data-target="' + idkey + '">-<span>';
            }
            dom += '<li class="clearfix" id="rule-tab-' + idkey + '"" data-target="' + idkey + '">' + decodeURI(obj_get(fields_label, i, i)) + del + '</li>';
        }
        return dom;
    }

    /**
     * 获取测试数据dom
     * @param  array rule
     * @return string
     */
    function getRuleTestDom(rule, ruleKey) {
        var dom = '';
        var ruleKey = ruleKey || "content";
        for (var i in rule) {
            idkey = i.replace(/%/g, '');
            dom += '<div id="rule-test-' + idkey + '" class="form-group row">\
                                <label class="label-control col-sm-3">' + decodeURI(i) + '</label>\
                                <div class="col-sm-9">\
                                    <input class="form-control" type="text" name="rules[' + ruleKey + '][' + i + '][test_data]" value="' + rule[i]['test_data'] + '" />\
                                </div>\
                             </div>';
        }
        return dom;
    }

    /**
     * tab 切换
     * @return
     */

    function tabSwitch(type) {
        // 整体tab switcher
        var tabSwitcher = new TabSwitcher();
        type = type || "wordpress";
        tabSwitcher.add("task-info", jQuery(".tab-task-info"), jQuery(".task-info"));
        if (type == "wordpress") {
            // 发布到文章
            tabSwitcher.remove("task-rule-sqlite");
            tabSwitcher.remove("task-rule-term");
            tabSwitcher.add("task-rule", jQuery(".tab-rule"), jQuery(".post-tab-content"));
        } else if (type == "sqlite") {
            // 发布到sqlite
            tabSwitcher.remove("task-rule");
            tabSwitcher.remove("task-rule-term");
            tabSwitcher.add("task-rule-sqlite", jQuery(".tab-rule-sqlite"), jQuery(".sqlite-tab-content"));
        } else if (type == "term") {
            // 发布到分类
            tabSwitcher.remove("task-rule");
            tabSwitcher.remove("task-rule-sqlite");
            tabSwitcher.add("task-rule-term", jQuery(".tab-rule-term"), jQuery(".term-tab-content"));
        }

        tabSwitcher.add("tab-rule-test", jQuery(".tab-rule-test"), jQuery(".rule-test"));
        tabSwitcher.setNextDOM(jQuery("#next-step"));
        tabSwitcher.setPrevDOM(jQuery("#prev-step"));
        tabSwitcher.setEndDOM(jQuery("#submit"));
        tabSwitcher.run();
    }

    /**
     * 使得content rule为激活状态
     * @return
     */
    function activateRule(key) {
        jQuery(".rule-tab li").removeClass('active');
        jQuery(".rule-tab li#rule-tab-" + key).addClass('active');
        jQuery(".rule-container").hide();
        jQuery("#rule-" + key).show();
        currentTabKey = key; //全局tab key
    }

    /**
     * 内容规则切换
     * @return
     */
    function ruleSwitch() {
        jQuery(".rule-tab").delegate('li', 'click', function() {
            var key = jQuery(this).attr('data-target');
            activateRule(key);
        });
    }

    /**
     * 添加发布字段
     */
    function addRule() {
        jQuery(".rule-tab .add-rule").click(function() {
            var key = encodeURI(jQuery(this).parent().find(".rule-key").val());
            jQuery(this).parent().find(".rule-key").val("")
            if (!key) {
                alert('输入key');
                return false;
            }
            var rule = {}
            rule[key] = {
                'fields': '',
                'condition': {
                    'min_len': 1,
                    'include': '',
                    'exclude': ''
                },
                'description': '',
                'builtin': 0,
                'serialize': '',
                'test_data': ''
            };
            var idkey = key.replace(/%/g, '');

            // 添加tab
            ruleTabDom = getRuleTabDom(rule);
            jQuery(this).parents(".rule-tab").append(ruleTabDom);

            // 添加规则表单
            var tabName = jQuery(this).attr("data-tab-name");
            var ruleDom = getRuleDom(rule, tabName);
            jQuery(this).parents(".tab-content").find(".rule-content").append(ruleDom);
            activateRule(idkey);

            // 添加测试发布的数据表单
            var ruleTestDom = getRuleTestDom(rule, tabName);
            jQuery("#rule-test").append(ruleTestDom);
        });

        jQuery(".rule").delegate('.del-rule', 'click', function() {
            var target = jQuery(this).attr('data-target');
            jQuery("li#rule-tab-" + target).remove();
            jQuery("#rule-" + target).remove();
            jQuery("#rule-test-" + target).remove();
        });
    }

    // 根据发布类型初始化tab
    function initTabByPublishType(val) {
        if (val == "wordpress") {
            jQuery(".tab-rule").show();
            jQuery(".tab-rule-term").hide();
            jQuery(".tab-rule-sqlite").hide();
            tabSwitch("wordpress");
        } else if (val == "sqlite") {
            jQuery(".tab-rule").hide();
            jQuery(".tab-rule-term").hide();
            jQuery(".tab-rule-sqlite").show();
            tabSwitch("sqlite");
        } else if (val == "term") {
            jQuery(".tab-rule").hide();
            jQuery(".tab-rule-sqlite").hide();
            jQuery(".tab-rule-term").show();
            tabSwitch("term");
        }
    }

    /**
     * 初始化表单数据
     * @return
     */
    function initFormData(formData) {

        var form = new FormCreater();
        form.text("name", formData["name"], "规则名称", "填写发布规则名称", true)
            .select("rules[publish_type]", {
                "wordpress": "发布到本地WordPress文章",
                "term": "发布到本地WordPress分类",
                "sqlite": "保存为SQLite数据库"
            }, formData["rules"]["publish_type"], "发布方式", "填写发布方式，默认为发布到本地wordpress", true);
        jQuery(".task-info").html(form.getInput());
        // publish type
        jQuery("select[name='rules[publish_type]']").change(function(e) {
            var val = jQuery(this).val();
            initTabByPublishType(val);
        });

        var val = jQuery("select[name='rules[publish_type]']").val();
        initTabByPublishType(val);

        // 初始化sqlite发布模块
        var form = new FormCreater();

        // 兼容老版本，2.0去掉该逻辑
        // 后续使用新的数据格式中都包含content字段
        var sqlitePath = ""
        if (formData["rules"].hasOwnProperty("content")) {
            sqlitePath = formData["rules"]["sqlite"]["path"];
        }
        form.text("rules[sqlite][path]", sqlitePath, "SQLite路径", "填写相对于wordpress根目录的相对路径");
        jQuery(".rule-sqlite").html(form.getInput());

        // 分类规则
        if (formData["rules"].hasOwnProperty("term")) {
            ruleContent = formData['rules']['term']
            var termRuleDom = getRuleDom(ruleContent, "term");
            var termRuleTabDom = getRuleTabDom(ruleContent);
            jQuery(".term-tab-content .rule-content").append(termRuleDom);
            jQuery(".term-tab-content .rule-tab").append(termRuleTabDom);
        }

        jQuery('input[name="id"]').val(formData['id']);

        // 兼容原有的数据类型，2.0版本后去掉
        ruleContent = formData['rules'].hasOwnProperty("content") ? formData['rules']['content'] : formData['rules'];
        var ruleDom = getRuleDom(ruleContent);
        var ruleTabDom = getRuleTabDom(ruleContent);
        var ruleTestDom = getRuleTestDom(ruleContent);
        jQuery(".post-tab-content .rule-content").append(ruleDom);
        jQuery(".post-tab-content .rule-tab").append(ruleTabDom);
        jQuery("#rule-test").append(ruleTestDom);
        var key = '';
        for (var i in ruleContent) {
            key = i;
            break;
        }
        key = key.replace(/%/g, '');
        activateRule(key);
    }

    /**
     * 规则测试
     */
    function ruleTest() {
        jQuery("#rule-test-btn").click(function() {
            jQuery('#rule-test-table').html('请求发布接口...');
            var a = jQuery("input[name*='test_data']");
            requestData = {};
            a.each(function(k, v) {
                var dom = jQuery(v);
                var name = dom.attr('name').replace(/rules\[content\]\[(.*)\]\[test_data\]/g, '$1');
                var value = dom.val();
                requestData[name] = value;
            });
            jQuery.ajax({
                'url': ajaxurl + '?action=publish_rule_test',
                'method': 'POST',
                'dataType': 'json',
                'data': requestData,
                'success': function(data) {
                    console.log(data);
                    jQuery('#rule-test-table').html(data['data']);
                }
            });
        });
    }

    jQuery(document).ready(function($) {
        formData = formData || defaultFormData;
        // 初始化form数据
        initFormData(formData);
        // 内容规则切换
        ruleSwitch();
        // 添加内容规则
        addRule();
        // 规则测试
        ruleTest();
    });
</script>

<div id="imwprobot">
    <?php  if (!empty($['msg'])) { if ($['errno'] == 0) { echo '<p class="alert alert-success">'; } else { echo '<p class="alert alert-warning">'; } echo $['msg']; echo '</p>'; } ?>
    <div class="row">
        <div class="col-12">

            <form id="form" action="" method="POST">
                <ul class="tab tab-publish clearfix">
                    <li class="tab-task-info">基本信息</li>
                    <li class="tab-rule">文章字段</li>
                    <li class="tab-rule-sqlite hidden">SQLite选项</li>
                    <li class="tab-rule-term hidden">分类字段</li>
                    <li class="tab-rule-test">测试发布</li>
                </ul>
                <p style="padding:10px;margin:0;border-bottom:1px solid #ccc;">全局可发布模板变量: 正文首图:<code>$first_image$</code> 当前页面链接:<code>$current_url$</code></p>

                <input type="hidden" name="id" value="">

                <!--{{基本信息区域-->
                <div class="task-info tab-content">
                </div>
                <!--基本信息区域}}-->

                <!--{{规则区域-->
                <div class="rule tab-content post-tab-content">
                    <div class="row">
                        <div class="col-3">
                            <div class="rule-tab">
                                <div class="form-inline">
                                    <input class="form-control col-8 ml-1 rule-key" type="text" id="rule-key" value="" placeholder="自定义字段">
                                    <span class="add-rule btn btn-outline-primary btn-sm col" data-tab-name="content">添加</span>
                                </div>
                                <!--菜单区域将会用contentrule填充-->
                            </div>
                        </div>

                        <!--{{内容规则-->
                        <div class="col-9">
                            <div id="rule-container" class="rule-content">
                                <!--js将会填充这块区域-->
                            </div>
                        </div>
                        <!--内容规则}}-->

                    </div>
                </div>
                <!--规则区域}}-->

                <!--{{sqlite规则-->
                <div class="rule-sqlite tab-content common-tab-content sqlite-tab-content hidden"></div>
                <!--sqlite规则}}-->


                <!--{{分类发布规则区域-->
                <div class="rule tab-content term-tab-content">
                    <div class="row">
                        <div class="col-3">
                            <div class="rule-tab">
                                <div class="form-inline">
                                    <input class="form-control col-8 ml-1 rule-key" type="text" id="rule-key" value="" placeholder="自定义字段">
                                    <span class="add-rule btn btn-outline-primary btn-sm col" data-tab-name="term">添加</span>
                                </div>
                                <!--菜单区域将会用contentrule填充-->
                            </div>
                        </div>

                        <!--{{内容规则-->
                        <div class="col-9">
                            <div class="rule-content">
                                <!--js将会填充这块区域-->
                            </div>
                        </div>
                        <!--内容规则}}-->

                    </div>
                </div>
                <!--分类规则区域}}-->


                <!--{{测试规则是否符合预期区域-->
                <div class="rule-test tab-content common-tab-content">
                    <div id="rule-test">
                    </div>
                    <span class="btn btn-outline-primary" id="rule-test-btn">点击测试发布</span>
                    <div class="bg-info" id="rule-test-table"></div>
                </div>

                <!--测试规则是否符合预期区域-->
                <div>
                    <span class="btn btn-outline-primary tab-btn" id="prev-step">上一步</span>
                    <span class="btn btn-outline-primary tab-btn" id="next-step">下一步</span>
                    <input type="submit" class="btn btn-outline-primary tab-btn" id="submit" value="提交" />
                </div>

            </form>

        </div>
    </div>
</div>