<style type="text/css">
    #right-block {
        position: relative;
        float: right;
        width: 39%;
        padding: 0;
        height: 100%;
        padding: 0;
    }

    #right-block .title {
        text-indent: 10px;
        background-color: #fff;
        margin: 0;
        padding: 8px 0px;
        border: 1px solid #ccc;
    }


    #imwprobot-status-log {
        font-family: Consolas, Monaco, monospace;
    }

    #imwprobot-status-log pre {
        border: 1px solid #ccc;
        border-top: none;
        background: #333;
        padding: 10px;
        margin: 0;
        color: #fff;
        overflow: scroll;
        height: 550px;
        max-height: 520px;
    }
</style>
<div class="wrap">
    <h1>任务列表</h1>
    <p>
        <a href="?page=imwprobot&subpage=add" class="button button-outline-primary">添加任务</a>
        <input type="file" id="task-file" name="task_file" style="display:none" onchange="uploadFile()" />
        <a href="#" id="import-task" class="button button-outline-primary">导入任务</a>
    </p>
    <div style="width:60%;float:left">
        <table class="wp-list-table widefat fixed striped">
            <thead>
                <tr>
                    <th scope="col" class="manage-column">任务标题</th>
                    <th scope="col" class="manage-column">任务url</th>
                    <th scope="col" class="manage-column">下次执行</th>
                    <th scope="col" class="manage-column">操作</th>
                </tr>
            </thead>

            <tbody>
                <?php  $ = admin_url('admin-ajax.php?action=imwprobot_task_export&task_id='); foreach ($['data']['list'] as $ => $) { $ = '<a class="execute-hm" href="#" data-id="' . $['id'] . '">抓取一次</a>'; if ($['task_status'] == 0) { $ .= " | <a href=\"?page=imwprobot&action=start&task_id={$['id']}\">开始任务</a>"; } else { if ($['task_status'] == 1) { $ .= " | <a href=\"?page=imwprobot&action=pause&task_id={$['id']}\">暂停任务</a>"; } } $ = json_decode($['value'], true); echo <<<EOF
                    <tr>
                            <td>{$['name']}
                            <div class="row-actions">
                                <span class="edit">
                                <a href="?page=imwprobot&subpage=add&action=edit&id={$['id']}">编辑</a> | </span>
                                <span class="trash"><a href="#" data-href="?page=imwprobot&action=delete&task_id={$['id']}" class="confirm-action submitdelete" >删除</a> | </span>
                                <span class="view"><a href="?page=imwprobot&subpage=posts&task_id={$['id']}">抓取队列</a> | </span>
                                <span class="view"><a href="{$}{$['id']}">导出任务</a> | </span>
                                <span class="view"><a class="imwpf-confirm" data-href="?page=imwprobot&action=delete_queue&task_id={$['id']}">清空队列</a></span>
                                </div>
                            </td>
                            <td>{$['url']}</td>
                            <td>{$['next_execute']}</td>
                            <td>
                                {$}
                            </td>
                        </tr>
EOF;
} ?>
            </tbody>
        </table>
        <ul id="pagenavi">
            <?php  echo $["data"]["pagenavi"]; ?>
        </ul>
    </div>

    <div id="right-block">

        <div class='imwprobot-user'>
            <p class="title">账户信息</p>
            <div class="imwprobot-user-content clearfix">
                <div class="col-xs-12 clearfix">
                    <div class="domain">剩余时长</div>
                    <div class="all-time">
                        <span class="left-text"><?php  echo $['data']['left_time']; ?></span>
                        <span class="left-time"></span>
                    </div>
                </div>
            </div>
        </div>

        <div>
            <p class="title">公告</p>
            <div class="imwprobot-user-content clearfix">
                <div class="col-xs-12 buy-link">
                    <?php  echo $['data']['public_notice']; ?>
                </div>
            </div>
        </div>

        <div id='imwprobot-status-log'>
            <p class="title">日志</p>
            <pre></pre>
        </div>

    </div>
</div>

<?php  add_thickbox(); ?>
<div id="my-content-id" style="display:none;">
    手动执行中...
    <table id="crawl-result" class="wp-list-table widefat fixed striped">
        <tr>
            <th>标题</th>
            <th>发现新网址数</th>
        </tr>
    </table>
</div>

<script type="text/javascript">
    function uploadFile() {
        var filePath = jQuery("#task-file").val();
        if (!filePath) {
            alert("文件不存在");
            return false;
        }

        //设置上传文件类型
        if (filePath.indexOf(".imwprobot") == -1) {
            alert("导入的文件不正确");
            return false;
        }
        var form = new FormData();
        form.append('file', jQuery('#task-file')[0].files[0]);
        //上传文件
        jQuery.ajax({
            url: ajaxurl + '?action=imwprobot_task_import',
            type: 'post',
            data: form,
            dataType: 'json',
            cache: false,
            //阻止Ajax将参数转成成String类型的键值对，需要设置processData属性为false，
            processData: false,
            //form的enctype="multipart/form-data"才能上传文件。Ajax的默认编码方式是application/x-www-form-urlencoded
            contentType: false,

            success: function(r) {
                if (r.errno != 0) {
                    alert(r.msg);
                } else {
                    alert("导入成功");
                    window.location = "";
                }
            }
        });

        return false;
    }

    jQuery(document).ready(function($) {
        $('.execute-hm').click(function() {
            var taskId = $(this).attr('data-id');
            $.get(ajaxurl + '?action=manual_crawl&id=' + taskId);
            alert("触发成功，请在右侧查看日志");
            return false;
        });

        // tail log
        var logs_filter = {};

        function tailLog() {
            $.ajax({
                url: ajaxurl + '?action=imwprobot_tail_log',
                type: "get",
                dataType: 'json',
                success: function(data) {
                    if (data.errno != 0) {
                        $('#imwprobot-status-log pre').append(data.msg + "\n");
                        return;
                    }
                    if (data.data.log.length == 0) {
                        $('#imwprobot-status-log pre').html("暂时没有采集日志...\n");
                        return;
                    }
                    var logContent = "";
                    for (i in data.data.log) {
                        var item = JSON.parse(data.data.log[i]);
                        if (!item || !item.hasOwnProperty("_id")) {
                            continue;
                        }
                        if (logs_filter.hasOwnProperty(item["_id"])) {
                            continue;
                        }
                        logs_filter[item["_id"]] = 0;
                        logContent += '[' + item["_datetime"] + '] 采集 ' + item["getExecuteable"]["url"];
                        if (item.hasOwnProperty('new_post_count') && item["new_post_count"] > 0) {
                            logContent += " 成功，发现新文章" + item["new_post_count"] + "篇，已加入采集队列";
                        } else if (item.hasOwnProperty("execute.publishRule")) {
                            logContent += " " + item["execute.publishRule"];
                        } else if (item.hasOwnProperty("errmsg")) {
                            logContent += " " + item["errmsg"];
                        } else if (item.hasOwnProperty("execute.spider")) {
                            logContent += " " + item["execute.spider"];
                        } else {
                            logContent += ' 成功';
                        }
                        logContent += "\n";
                    }
                    // console.log(logContent);
                    $('#imwprobot-status-log pre').append(logContent);
                    $('#imwprobot-status-log pre').scrollTop(9999999);
                },
                error: function(e) {
                    $('#imwprobot-status-log pre').append("读取失败，尝试继续读取...\n");
                }
            });

            setTimeout(function() {
                tailLog();
            }, 2000);
        }

        tailLog();

        $("#import-task").click(function() {
            $("#task-file").click();
        });

        var left_time_ratio = <?php  echo $['data']['left_time_s']; ?> / (864 * 365);
        if (left_time_ratio <= 1) {
            left_time_ratio = 1;
        } else if (left_time_ratio > 100) {
            left_time_ratio = 100;
        }
        var bgcolor = "#99CC66";
        if (left_time_ratio < 20) {
            var bgcolor = "#FF0033";
        } else if (left_time_ratio < 60) {
            var bgcolor = "#FF9900"
        }
        $(".imwprobot-user-content .left-time").css({
            "background": bgcolor
        }).animate({
            "width": left_time_ratio.toString() + "%"
        });

    });
</script>