<?php
 namespace imwprobot\modules\page; use imwpf\modules\Form; use imwpf\modules\Input; use imwprobot\modules\lib; use imwprobot\src\Config; class System extends Base { public function __construct() { parent::__construct(); } public function options() { $ = Config::read(); if (!empty($_POST)) { $ = Config::save(array('run_mode' => Input::str('run_mode'), "proxy_check_url" => Input::str("proxy_check_url"), "spider_node" => Input::str("spider_node"))); } $ = new Form("POST"); $->tab("base", "基础设置")->select("run_mode", array("web" => "用户访问触发", "crontab" => "定时任务"), $["run_mode"], "运行模式", "目前支持三种模式<br/>\n                1. 访问者触发表示每有一次用户访问触发一次采集<br/>\n                2. 定时任务，使用主机的定时任务功能定时方式采集接口进行采集<br/>")->info("cron_info", "定时访问接口为 " . admin_url("admin-ajax.php?action=imwprobot_auto_crawl&crawl_count=1") . "，<a href='http://www.imwpweb.com/5571.html' target='_blank'>点此查看设置方法</a>", "请设置定时任务接口")->hide(array("run_mode" => array("crontab")))->text("proxy_check_url", $["proxy_check_url"], "代理检测地址", "检测代理时会访问改地址，访问成功表示代理有效，访问失败表示代理无效")->select("spider_node", array("default" => "默认节点", "hk" => "香港节点"), $["spider_node"], "采集器节点", "设置采集器节点，<code>不要改动</code>。如果遇到频繁api返回结果为空，可联系作者开通其他节点"); $this->setFields("content", $->render()); $this->setFields("title", "系统信息"); } public function proxy() { $ = '<p>
            <a href="?page=imwprobot_system&__tab=proxy&action=add" class="button">添加代理</a>
            <a class="button" id="check-proxy">验证代理</a>
            <a class="button" id="check-invalid-proxy">验证无效代理</a>
            <a class="button" id="check-valid-proxy">验证有效代理</a>
        </p>'; $ = new lib\Option(); $ = $->gets("proxy"); $ .= '<table id="imwprobot-proxy" class="wp-list-table widefat fixed striped">
        <thead><tr>
            <th>类型</th>
            <th>地址</th>
            <th>端口</th>
            <th>用户名</th>
            <th>密码</th>
            <th>是否有效</th>
            <th>操作</th>
        </tr></thead>'; foreach ($ as $) { $ = parse_url($["option_name"]); $ = $["option_value"]; $ .= "<tr class=\"proxy-{$}\" data-proxy=\"{$['option_name']}\">"; $ .= "<td>{$['scheme']}</td><td>{$['host']}</td><td>{$['port']}</td><td>{$['user']}</td><td>{$['pass']}</td>"; if ($ == "0") { $ .= "<td class=\"status\">未验证</td>"; } else { if ($ == "1") { $ .= "<td class=\"status\">有效</td>"; } else { if ($ == "-1") { $ .= "<td class=\"status\">无效</td>"; } } } $ .= "<td><a class=\"confirm-action\" data-href=\"?page=imwprobot_system&__tab=proxy&action=delete&id={$['id']}\">删除</a></td></tr>"; } $ .= '</table>'; $this->setFields("content", $); } private function ($) { if (!empty($["username"])) { $ = $["scheme"] . "://" . $["username"] . ":" . $["password"] . "@" . $["ip"] . ":" . $["port"]; } else { $ = $["scheme"] . "://" . $["ip"] . ":" . $["port"]; } return $; } public function addProxy() { $ = '<a href="?page=imwprobot_system&__tab=proxy&action=add" class="button button-primary">添加代理</a>'; $ = new lib\Option(); if (!empty($_POST)) { $ = $this->($_POST); $ = parse_url($); if (empty($["scheme"]) || empty($["host"]) || empty($["port"])) { $this->setError("代理格式不对，请重新添加"); } else { if ($->addOption("proxy", $, "0")) { $this->setSuccess("添加成功，返回 <a href='?page=imwprobot_system&__tab=proxy'>列表</a>"); } else { $this->setError("添加失败，可能该代理已经添加过"); } } } $ = new Form(); $->select("scheme", array("socks5" => "SOCKS5", "socks4" => "SOCKS4", "http" => "HTTP"), "", "代理类型")->text("ip", "", "IP")->text("port", "", "端口")->text("username", "", "用户名")->text("password", "", "密码")->text("check_url", "http://www.baidu.com", "检查地址"); $ .= $->render(); $this->setFields("content", $); } public function deleteProxy() { if (empty($_GET['id'])) { $this->setError("参数有误"); return; } $ = new lib\Option(); $ = intval($_GET['id']); $->delete($); echo "<script>window.location=\"?page=imwprobot_system&__tab=proxy\"</script>"; } public function watermark() { $ = '<p>
            <a href="?page=imwprobot_system&__tab=watermark&action=add" class="button">添加水印配置</a>
        </p>'; $ = lib\Option::gets("watermark"); $ .= '<table id="imwprobot-watermark" class="wp-list-table widefat fixed striped">
        <thead><tr>
            <th>配置名</th>
            <th>水印</th>
            <th>位置</th>
            <th>最小图片宽</th>
            <th>最小图片高</th>
            <th>操作</th>
        </tr></thead>'; foreach ($ as $) { $ = json_decode($["option_value"], true); $ .= "<tr><td>{$["option_name"]}</td>"; $ .= "<td>\n            <img src='{$['image']}' style='width:130px;height:auto;' /></td>\n            <td>{$['position']}</td>\n            <td>{$['min_width']}px</td>\n            <td>{$['min_height']}px</td>\n            <td><a class=\"confirm-action\" data-href=\"?page=imwprobot_system&__tab=watermark&action=delete&id={$['id']}\">删除</a>\n                | <a href=\"?page=imwprobot_system&__tab=watermark&action=add&name={$["option_name"]}\">编辑</a>\n            </td>\n            </tr>"; } $ .= '</table>'; $this->setFields("content", $); } public function addWatermark() { $ = new \imwprobot\modules\lib\Option(); $ = array("image" => "", "path" => "", "position" => "", "min_width" => "", "min_height" => "", "margin" => ""); $ = 0; $ = Input::xss(Input::str("name")); if (!empty($)) { $ = lib\Option::get("watermark", $); if ($) { $ = $["id"]; $ = json_decode($["option_value"], true); } } if (!empty($_POST)) { $ = Input::int("id", 0); $ = array("image" => Input::str("image"), "path" => Input::str("image_path"), "position" => Input::int("position"), "min_width" => Input::int("min_width"), "min_height" => Input::int("min_height"), "margin" => Input::int("margin")); if (!empty($)) { if ($ > 0) { $->update("watermark", $, json_encode($), $); } else { $->set("watermark", $, json_encode($)); } $this->setSuccess("保存成功，<a href=\"admin.php?page=imwprobot_system&__tab=watermark\">返回水印列表</a>"); $ = lib\Option::get("watermark", $); if ($) { $ = json_decode($["option_value"], true); } } else { $this->setError("请设置水印配置名称"); } } $ = new Form("POST"); $->text("name", $, "配置名称")->image("image", $["image"], $['path'], "水印图片")->text("min_width", $["min_width"], "单位px, 最小图片宽度", "当图片宽度大于这里设置的宽度才会添加水印")->text("min_height", $["min_height"], "单位px, 最小图片高度", "当图片高度大于这里设置的高度才会添加水印")->text("margin", $["margin"], "水印边距", "单位px，水印四周边距")->hidden("id", $)->select("position", array("0" => "随机", "1" => "顶端居左", "2" => "顶端居中", "3" => "顶端居右", "4" => "中部居左", "5" => "中部居中", "6" => "中部居右", "7" => "底部居左", "8" => "底部居中", "9" => "底部居右"), $["position"], "水印位置")->button("preview", "预览水印图片", "预览"); $this->setFields("content", $->render()); $this->setFields("title", "添加水印"); } public function deleteWatermark() { if (empty($_GET['id'])) { $this->setError("参数有误"); return; } $ = new lib\Option(); $ = intval($_GET['id']); $->delete($); echo "<script>window.location=\"?page=imwprobot_system&__tab=watermark\"</script>"; } }