<div class="wrap">
    <h1>采集模块</h1>
    <p>
        <a href="?page=imwprobot_crawl&action=add" class="button button-outline-primary">添加采集模块</a>
        <input type="file" id="rule_file" name="rule_file" style="display:none" onchange="uploadFile()"/>
        <button class="import-rule button button-outline-primary">导入采集模块</button>

    </p>
    <?php  if (isset($['error'])) { echo "<div class='notice notice-error'><p>{$['error']}</p></div>"; } if (isset($['success'])) { echo "<div class='notice notice-success'><p>{$['success']}</p></div>"; } ?>
    <table class="wp-list-table widefat fixed striped">
        <thead>
            <tr>
                <th scope="col" class="manage-column">模块名称</th>
            </tr>
        </thead>

        <tbody>
            <?php  if (!empty($['data'])) { $ = admin_url('admin-ajax.php?action=imwprobot_rule_export&rule_id='); foreach ($['data'] as $) { echo <<<EOF
                    <tr>
                            <td>{$['name']}
                            <div class="row-actions">
                                <span class="edit">
                                <a href="?page=imwprobot_crawl&action=edit&rule_id={$['id']}">编辑</a> | </span>
                                <a href="{$}{$['id']}">导出</a> | </span>
                                <a href="?page=imwprobot_crawl&action=copy&rule_id={$['id']}">复制</a> | </span>
                                <span class="trash"><a href="#" data-href="?page=imwprobot_crawl&action=delete&rule_id={$['id']}" class="submitdelete confirm-action">删除</a></span>
                            </div>
                            </td>
                        </tr>
EOF;
} } ?>
        </tbody>

    </table>
</div>

<?php  add_thickbox(); ?>
<div id="my-content-id" style="display:none;">
    <p>手动执行中...</p>
</div>


<script type="text/javascript">
    
    function uploadFile() {
        var filePath = jQuery("#rule_file").val();
        if (!filePath) {
            return false;
        }

        //设置上传文件类型
        if (filePath.indexOf(".imwprobot") != -1) {
            var form = new FormData();
            form.append('file', jQuery('#rule_file')[0].files[0]);
            //上传文件
            jQuery.ajax({
                url: ajaxurl + '?action=imwprobot_rule_import',
                type: 'post',
                data: form,
                dataType: 'json',
                cache: false,
                //阻止Ajax将参数转成成String类型的键值对，需要设置processData属性为false，
                processData: false,
                //form的enctype="multipart/form-data"才能上传文件。Ajax的默认编码方式是application/x-www-form-urlencoded
                contentType: false,

                success: function (r) {
                    if (r.errno != 0) {
                        alert(r.msg);
                    } else {
                        var content = '<tr>\
                            <td>'+r.data['name']+'\
                            <div class="row-actions">\
                                <span class="edit">\
                                <a href="?page=imwprobot_crawl&action=edit&rule_id=' + r.data['rule_id'] + '">编辑</a> | </span>\
                                <a href="' + ajaxurl + '?action=imwprobot_rule_export&rule_id=' + r.data['rule_id'] + '">导出</a> | </span>\
                                <span class="trash"><a href="#" data-href="?page=imwprobot_crawl&action=delete&rule_id=' + r.data['rule_id'] + '" class="submitdelete confirm-action">删除规则</a></span>\
                            </div>\
                            </td>\
                        </tr>';
                        jQuery('.wp-list-table tbody').append(content);
                    }
                }
            });
            return false;
        }

        alert("导入的文件不正确");
        return false;
    }

    jQuery(document).ready(function($) {
        $('.execute-hm').click(function(){
            $('#my-content-id').html('<p>执行中...</p>');
            var taskId = $(this).attr('data-id');
            $.ajax({
                url: ajaxurl + '?action=spider_tasklist&id=' + taskId,
                type:"get",
                dataType:'json',
                success:function(data){
                    if (data.code == 1){
                        var htmlContent = '<p>入库成功数据</p><table class="wp-list-table widefat fixed striped"><tr><td>链接</td><td>标题</td></tr>';
                    } else {
                        var htmlContent = '<p>入库失败</p><table class="wp-list-table widefat fixed striped"><tr><td>链接</td><td>标题</td></tr>';
                    }
                    for(var i in data.content) {
                        htmlContent += '<tr><td>'+i+'</td><td>'+data.content[i]+'</td></tr>';
                    }
                    htmlContent += '</table>'
                    $('#TB_ajaxContent').html(htmlContent);
                }
            });
        });

        $(".import-rule").click(function() {
            $("#rule_file").click();
        });
    });
</script>