<?php
 use imwpf\modules\Form; ?>
<div class="wrap">
    <h1>抓取队列</h1>

    <p><a class="thickbox button" href="#TB_inline?width=600&height=550&inlineId=add-posts-to-queue">手动加入链接</a></p>

    <div id="pagenavi">
        <?php  echo $['pagenavi']; ?>
    </div>

    <table class="wp-list-table widefat fixed striped">
        <thead>
            <tr>
                <th style="width:5%">ID</th>
                <th scope="col" class="manage-column">url</th>
                <th scope="col" class="manage-column">附加信息</th>
                <th scope="col" class="manage-column">状态</th>
                <th scope="col" class="manage-column">创建时间</th>
            </tr>
        </thead>

        <tbody>
            <?php  $ = isset($_GET['p']) ? intval($_GET['p']) : 1; $ = "post"; if ($["publish_rule"]['rules']["publish_type"] == "term") { $ = "term"; } else { if ($["publish_rule"]['rules']["publish_type"] == "sqlite") { $ = "sqlite"; } } foreach ($['posts'] as $) { $ = json_decode($['content'], true); $ = date('Y-m-d H:i:s', $['create_time']); if ($['post_id'] == 0) { $ = '等待执行'; if (isset($['rtimes']) && $['rtimes'] > 5) { $ = "<span style='color:red'>失败, 已尝试抓取{$['rtimes']}次</span>"; } } else { if ($['post_id'] == 1) { $ = '<span style="color:green">已完成但不满足入库条件</span>'; } else { $ = '<span style="color:green">已入库</span>'; if ($ == "post") { $ = get_permalink($['post_id']); } else { if ($ == "term") { $ = get_category_link($['post_id']); } else { if ($ == "sqlite") { $ = admin_url("admin-ajax.php?action=sqlite_get_post_content&task_id=" . $["task_id"] . "&url=" . urlencode($["url"])); } } } $['url'] = '<a target="_blank" href="' . $ . '">' . $['url'] . '</a>'; } } $ = ""; $ = array("title" => "标题", "level" => "页面深度", "rtimes" => "抓取次数", "thumb" => "列表页封面图"); foreach ($ as $ => $) { $ .= $[$] . ": " . $ . "<br/>"; } echo <<<EOF
                    <tr>
                            <td>{$['id']}</td>
                            <td>{$['url']}
                            <div class="row-actions">
                                <span class="trash">
                                    <a href="?page=imwprobot&subpage=posts&action=delete&task_id={$['task_id']}&post_id={$['id']}&p={$}" class="submitdelete" >删除</a> | 
                                </span>
                                <span><a class="thickbox task-get-post" href="#TB_inline?width=600&height=550&inlineId=my-content-id" data-id="{$['id']}" data-task-id="{$['task_id']}">手动执行</a></span>
                            </div>
                            </td>
                            <td>{$}</td>
                            <td>{$}</td>
                            <td>{$}</td>
                        </tr>
EOF;
} ?>
        </tbody>

    </table>

    <div id="pagenavi">
        <?php  echo $['pagenavi']; ?>
    </div>
</div>

<?php  add_thickbox(); ?>
<div id="my-content-id" style="display:none;"></div>

<div id="add-posts-to-queue" class="hidden">
    <div id="form-add-posts-to-queue">
        <?php  $ = new Form(); $->text("url", "", "链接模板", "输入链接模板，可使用的占位符为<code>{1}</code>和<code>{2}</code> ，比如http://www.imwpweb.com/{1}.html"); $->select("level", array("0" => "0(列表页)", "1" => "1(文章页)"), array(), "链接层级", "选择链接层级"); $->textN("place1", array("起始值", "结束值", "步长"), array(0, 0, 1), "占位符{1}", "需要替换占位符1的内容，一般用于分页链接生成"); $->textarea("place2", "", "占位符{2}", "需要替换占位符2的内容"); echo $->render(false); ?>
        <div style="padding: 0px 20px">
            <button class="create button button-primary" style="width:100%; margin-bottom:50px">生成</button>
            <textarea class="output" cols=60 rows=10 style="width:100%"></textarea>
            <p class="insert-result"></p>
            <div class="normal-form-container">
                <button class="insert button button-primary" style="width:100%" data-task-id="<?php  echo intval($_GET['task_id']); ?>">入库</button>
            </div>
        </div>
    </div>
</div>

<script type="text/javascript">
    jQuery(document).ready(function($) {

        $('.task-get-post').click(function() {
            $('#my-content-id').html('<p>执行中...</p>');
            var itemID = $(this).attr('data-id');
            var taskID = $(this).attr('data-task-id');
            $.ajax({
                url: ajaxurl + '?action=manual_crawl_post&post_id=' + itemID + '&task_id=' + taskID,
                type: "get",
                dataType: 'json',
                success: function(data) {
                    if (data.errno == 0) {
                        var htmlContent = '<p>运行成功</p><table class="wp-list-table widefat fixed striped">';
                        console.log(data.data.content[0]);
                        for (i in data.data.content[0]) {
                            htmlContent += '<tr><td>' + i + '</td><td>' + data.data.content[0][i] + '</td></tr>';
                        }
                    } else {
                        var htmlContent = '<p>错误</p><table class="wp-list-table widefat fixed striped">';
                        htmlContent += '<tr><td>' + data.msg + '</td></tr>';
                    }
                    htmlContent += '</table>'
                    $('#TB_ajaxContent').html(htmlContent);
                },
                error: function(e) {
                    console.log(e)
                    var htmlContent = '<p>可能发生了一些不可预知的错误，比如超出最大运行内存了等等</p><table class="wp-list-table widefat fixed striped">';
                    htmlContent += '<tr><td>' + e.responseText + '</td></tr></table>';
                    $('#TB_ajaxContent').html(htmlContent);
                }
            });
        });

        $("#form-add-posts-to-queue .insert").click(function() {
            var task_id = $(this).attr("data-task-id");
            var links = $("#form-add-posts-to-queue .output").val();
            if (links.length == 0) {
                return ;
            }
            var level = $("select[name=level]").val();
            console.log(level);
            $("#form-add-posts-to-queue .insert-result").html("添加中，请不要关闭此页面...<br/>");

            var linksArray = links.split("\n");
            var url = ajaxurl + '?action=imwprobot_add_post_links&task_id=' + task_id;
            var currentIndx = 0;
            var batch = 100;

            var callback = function(res) {
                var currentLinks = "";
                for (var i = currentIndx; i < currentIndx + batch; i++) {
                    if (i >= linksArray.length) {
                        break;
                    }
                    currentLinks += linksArray[i] + "\n";
                }
                currentIndx = i;
                if (currentLinks.length == 0) {
                    $("#form-add-posts-to-queue .insert-result").append("恭喜！已全部完成。现在可以关闭此页面");
                    return;
                }
                $("#form-add-posts-to-queue .insert-result").append(res.msg + "<br/>");
                var data = {
                    "links": currentLinks,
                    "task_id": task_id,
                    "level": level,
                }
                PostJSON(url, data, callback);
            }

            var currentLinks = "";
            for (var i = currentIndx; i < currentIndx + batch; i++) {
                if (i >= linksArray.length - 1) {
                    break;
                }
                currentLinks += linksArray[i] + "\n";
            }
            currentIndx = i;
            var data = {
                "links": currentLinks,
                "task_id": task_id,
                "level": level
            };
            PostJSON(url, data, callback);

        });

    });
</script>